/* A Bison parser, made by GNU Bison 1.875c.  */

/* Skeleton parser for Yacc-like parsing with Bison,
   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* Written by Richard Stallman by simplifying the original so called
   ``semantic'' parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Using locations.  */
#define YYLSP_NEEDED 0

/* If NAME_PREFIX is specified substitute the variables and functions
   names.  */
#define yyparse genExpYYparse
#define yylex   genExpYYlex
#define yyerror genExpYYerror
#define yylval  genExpYYlval
#define yychar  genExpYYchar
#define yydebug genExpYYdebug
#define yynerrs genExpYYnerrs


/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     TOK_QUESTIONMARK = 258,
     TOK_COLON = 259,
     TOK_OR = 260,
     TOK_AND = 261,
     TOK_BITWISEOR = 262,
     TOK_BITWISEXOR = 263,
     TOK_AMPERSAND = 264,
     TOK_NOTEQUAL = 265,
     TOK_EQUAL = 266,
     TOK_LESSTHAN = 267,
     TOK_GREATERTHAN = 268,
     TOK_LESSTHANOREQUALTO = 269,
     TOK_GREATERTHANOREQUALTO = 270,
     TOK_SHIFTLEFT = 271,
     TOK_SHIFTRIGHT = 272,
     TOK_PLUS = 273,
     TOK_MINUS = 274,
     TOK_STAR = 275,
     TOK_DIVIDE = 276,
     TOK_MOD = 277,
     TOK_ONESCOMPLEMENT = 278,
     TOK_NOT = 279,
     TOK_LPAREN = 280,
     TOK_RPAREN = 281,
     TOK_OCTALNUMBER = 282,
     TOK_DECIMALNUMBER = 283,
     TOK_UNSIGNEDNUMBER = 284,
     TOK_HEXADECIMALNUMBER = 285,
     TOK_BINARYNUMBER = 286,
     TOK_REALNUMBER = 287,
     TOK_REALEXPNUMBER = 288,
     TOK_ID = 289,
     TOK_IF = 290,
     TOK_ESCAPEDID = 291,
     TOK_COMMA = 292,
     TOK_COMPAREEQUAL = 293,
     TOK_FOURSTATEEQUAL = 294,
     TOK_FOURSTATENOTEQUAL = 295,
     TOK_WILDEQUAL = 296,
     TOK_WILDNOTEQUAL = 297,
     TOK_EXP = 298,
     TOK_BITWISEXNOR = 299,
     TOK_ARITHSHIFTLEFT = 300,
     TOK_ARITHSHIFTRIGHT = 301,
     TOK_TIMEUNIT = 302,
     TOK_UNBASEDUNSIZED = 303,
     TOK_STRINGLITERAL = 304,
     TOK_REDUCTIONNAND = 305,
     TOK_REDUCTIONOR = 306
   };
#endif
#define TOK_QUESTIONMARK 258
#define TOK_COLON 259
#define TOK_OR 260
#define TOK_AND 261
#define TOK_BITWISEOR 262
#define TOK_BITWISEXOR 263
#define TOK_AMPERSAND 264
#define TOK_NOTEQUAL 265
#define TOK_EQUAL 266
#define TOK_LESSTHAN 267
#define TOK_GREATERTHAN 268
#define TOK_LESSTHANOREQUALTO 269
#define TOK_GREATERTHANOREQUALTO 270
#define TOK_SHIFTLEFT 271
#define TOK_SHIFTRIGHT 272
#define TOK_PLUS 273
#define TOK_MINUS 274
#define TOK_STAR 275
#define TOK_DIVIDE 276
#define TOK_MOD 277
#define TOK_ONESCOMPLEMENT 278
#define TOK_NOT 279
#define TOK_LPAREN 280
#define TOK_RPAREN 281
#define TOK_OCTALNUMBER 282
#define TOK_DECIMALNUMBER 283
#define TOK_UNSIGNEDNUMBER 284
#define TOK_HEXADECIMALNUMBER 285
#define TOK_BINARYNUMBER 286
#define TOK_REALNUMBER 287
#define TOK_REALEXPNUMBER 288
#define TOK_ID 289
#define TOK_IF 290
#define TOK_ESCAPEDID 291
#define TOK_COMMA 292
#define TOK_COMPAREEQUAL 293
#define TOK_FOURSTATEEQUAL 294
#define TOK_FOURSTATENOTEQUAL 295
#define TOK_WILDEQUAL 296
#define TOK_WILDNOTEQUAL 297
#define TOK_EXP 298
#define TOK_BITWISEXNOR 299
#define TOK_ARITHSHIFTLEFT 300
#define TOK_ARITHSHIFTRIGHT 301
#define TOK_TIMEUNIT 302
#define TOK_UNBASEDUNSIZED 303
#define TOK_STRINGLITERAL 304
#define TOK_REDUCTIONNAND 305
#define TOK_REDUCTIONOR 306




/* Copy the first part of user declarations.  */



#include "svvalue.h"
#include "genexp.h"
#include "message.h"

#if defined(_MSC_VER)
#define MSDOS
#endif
#define YYDEBUG 0
#define YYSTYPE SVValue

#include <stdio.h>
#include <stdlib.h>

int genExpYYerror(const char *s)
{
  warn(g_genExpFileName,g_genExpLineNr,
       "Problem during constant expression evaluation: %s",s);
  g_genResultValue = SVValue((long)0);
  return 0;
}


int genExpYYlex();



/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

#if ! defined (YYSTYPE) && ! defined (YYSTYPE_IS_DECLARED)
typedef int YYSTYPE;
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
# define YYSTYPE_IS_TRIVIAL 1
#endif



/* Copy the second part of user declarations.  */


/* Line 214 of yacc.c.  */


#if ! defined (yyoverflow) || YYERROR_VERBOSE

# ifndef YYFREE
#  define YYFREE free
# endif
# ifndef YYMALLOC
#  define YYMALLOC malloc
# endif

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   define YYSTACK_ALLOC alloca
#  endif
# else
#  if defined (alloca) || defined (_ALLOCA_H)
#   define YYSTACK_ALLOC alloca
#  else
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning. */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
# else
#  if defined (__STDC__) || defined (__cplusplus)
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   define YYSIZE_T size_t
#  endif
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
# endif
#endif /* ! defined (yyoverflow) || YYERROR_VERBOSE */


#if (! defined (yyoverflow) \
     && (! defined (__cplusplus) \
	 || (defined (YYSTYPE_IS_TRIVIAL) && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  short yyss;
  YYSTYPE yyvs;
  };

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short) + sizeof (YYSTYPE))				\
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined (__GNUC__) && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  register YYSIZE_T yyi;		\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (0)
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (0)

#endif

#if defined (__STDC__) || defined (__cplusplus)
   typedef signed char yysigned_char;
#else
   typedef short yysigned_char;
#endif

/* YYFINAL -- State number of the termination state. */
#define YYFINAL  4
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   873

/* YYNTOKENS -- Number of terminals. */
#define YYNTOKENS  52
/* YYNNTS -- Number of nonterminals. */
#define YYNNTS  16
/* YYNRULES -- Number of rules. */
#define YYNRULES  109
/* YYNRULES -- Number of states. */
#define YYNSTATES  210

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   306

#define YYTRANSLATE(YYX) 						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const unsigned char yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const unsigned short yyprhs[] =
{
       0,     0,     3,     8,    10,    13,    16,    19,    22,    25,
      28,    31,    34,    37,    40,    44,    48,    52,    56,    60,
      64,    68,    72,    76,    80,    84,    88,    92,    96,   100,
     104,   108,   112,   116,   120,   124,   128,   132,   136,   140,
     144,   148,   152,   156,   160,   164,   168,   172,   176,   180,
     184,   189,   194,   199,   204,   209,   214,   219,   224,   229,
     234,   239,   244,   249,   254,   259,   264,   269,   274,   279,
     284,   289,   294,   299,   304,   309,   314,   320,   327,   331,
     333,   336,   342,   350,   357,   366,   369,   374,   378,   384,
     386,   388,   390,   392,   394,   396,   399,   402,   404,   406,
     408,   410,   412,   414,   416,   418,   420,   422,   424,   426
};

/* YYRHS -- A `-1'-separated list of the rules' RHS. */
static const yysigned_char yyrhs[] =
{
      53,     0,    -1,    35,    25,    54,    26,    -1,    59,    -1,
      19,    59,    -1,    18,    59,    -1,    24,    59,    -1,    23,
      59,    -1,     9,    59,    -1,    50,    59,    -1,     7,    59,
      -1,    51,    59,    -1,     8,    59,    -1,    44,    59,    -1,
      19,    55,    59,    -1,    18,    55,    59,    -1,    24,    55,
      59,    -1,    23,    55,    59,    -1,     9,    55,    59,    -1,
      50,    55,    59,    -1,     7,    55,    59,    -1,    51,    55,
      59,    -1,     8,    55,    59,    -1,    44,    55,    59,    -1,
      54,    38,    54,    -1,    54,    10,    54,    -1,    54,    12,
      54,    -1,    54,    14,    54,    -1,    54,    13,    54,    -1,
      54,    15,    54,    -1,    54,    18,    54,    -1,    54,    19,
      54,    -1,    54,    20,    54,    -1,    54,    21,    54,    -1,
      54,    22,    54,    -1,    54,    43,    54,    -1,    54,     6,
      54,    -1,    54,     5,    54,    -1,    54,     9,    54,    -1,
      54,     7,    54,    -1,    54,     8,    54,    -1,    54,    44,
      54,    -1,    54,    17,    54,    -1,    54,    16,    54,    -1,
      54,    45,    54,    -1,    54,    46,    54,    -1,    54,    39,
      54,    -1,    54,    40,    54,    -1,    54,    41,    54,    -1,
      54,    42,    54,    -1,    54,    38,    55,    54,    -1,    54,
      10,    55,    54,    -1,    54,    12,    55,    54,    -1,    54,
      14,    55,    54,    -1,    54,    13,    55,    54,    -1,    54,
      15,    55,    54,    -1,    54,    18,    55,    54,    -1,    54,
      19,    55,    54,    -1,    54,    20,    55,    54,    -1,    54,
      21,    55,    54,    -1,    54,    22,    55,    54,    -1,    54,
      43,    55,    54,    -1,    54,     6,    55,    54,    -1,    54,
       5,    55,    54,    -1,    54,     9,    55,    54,    -1,    54,
       7,    55,    54,    -1,    54,     8,    55,    54,    -1,    54,
      44,    55,    54,    -1,    54,    17,    55,    54,    -1,    54,
      16,    55,    54,    -1,    54,    45,    55,    54,    -1,    54,
      46,    55,    54,    -1,    54,    39,    55,    54,    -1,    54,
      40,    55,    54,    -1,    54,    41,    55,    54,    -1,    54,
      42,    55,    54,    -1,    54,     3,    54,     4,    54,    -1,
      54,     3,    55,    54,     4,    54,    -1,    25,    54,    26,
      -1,    56,    -1,    55,    56,    -1,    25,    20,    58,    20,
      26,    -1,    25,    20,    58,    11,    54,    20,    26,    -1,
      25,    20,    58,    57,    20,    26,    -1,    25,    20,    58,
      11,    54,    57,    20,    26,    -1,    37,    58,    -1,    37,
      58,    11,    54,    -1,    57,    37,    58,    -1,    57,    37,
      58,    11,    54,    -1,    65,    -1,    60,    -1,    62,    -1,
      61,    -1,    48,    -1,    49,    -1,    29,    47,    -1,    32,
      47,    -1,    64,    -1,    63,    -1,    32,    -1,    33,    -1,
      28,    -1,    29,    -1,    27,    -1,    31,    -1,    30,    -1,
      66,    -1,    67,    -1,    34,    -1,    36,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const unsigned short yyrline[] =
{
       0,   114,   114,   120,   122,   124,   126,   128,   130,   132,
     134,   136,   138,   140,   142,   144,   146,   148,   150,   152,
     154,   156,   158,   160,   163,   165,   167,   169,   171,   173,
     175,   177,   179,   181,   183,   185,   187,   189,   191,   193,
     195,   197,   199,   201,   203,   205,   207,   209,   211,   213,
     216,   218,   220,   222,   224,   226,   228,   230,   232,   234,
     236,   238,   240,   242,   244,   246,   248,   250,   252,   254,
     256,   258,   260,   262,   264,   266,   268,   270,   272,   275,
     277,   280,   282,   284,   286,   289,   291,   293,   295,   298,
     301,   304,   306,   308,   310,   313,   315,   318,   320,   323,
     325,   328,   330,   332,   334,   336,   339,   341,   344,   347
};
#endif

#if YYDEBUG || YYERROR_VERBOSE
/* YYTNME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals. */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "TOK_QUESTIONMARK", "TOK_COLON",
  "TOK_OR", "TOK_AND", "TOK_BITWISEOR", "TOK_BITWISEXOR", "TOK_AMPERSAND",
  "TOK_NOTEQUAL", "TOK_EQUAL", "TOK_LESSTHAN", "TOK_GREATERTHAN",
  "TOK_LESSTHANOREQUALTO", "TOK_GREATERTHANOREQUALTO", "TOK_SHIFTLEFT",
  "TOK_SHIFTRIGHT", "TOK_PLUS", "TOK_MINUS", "TOK_STAR", "TOK_DIVIDE",
  "TOK_MOD", "TOK_ONESCOMPLEMENT", "TOK_NOT", "TOK_LPAREN", "TOK_RPAREN",
  "TOK_OCTALNUMBER", "TOK_DECIMALNUMBER", "TOK_UNSIGNEDNUMBER",
  "TOK_HEXADECIMALNUMBER", "TOK_BINARYNUMBER", "TOK_REALNUMBER",
  "TOK_REALEXPNUMBER", "TOK_ID", "TOK_IF", "TOK_ESCAPEDID", "TOK_COMMA",
  "TOK_COMPAREEQUAL", "TOK_FOURSTATEEQUAL", "TOK_FOURSTATENOTEQUAL",
  "TOK_WILDEQUAL", "TOK_WILDNOTEQUAL", "TOK_EXP", "TOK_BITWISEXNOR",
  "TOK_ARITHSHIFTLEFT", "TOK_ARITHSHIFTRIGHT", "TOK_TIMEUNIT",
  "TOK_UNBASEDUNSIZED", "TOK_STRINGLITERAL", "TOK_REDUCTIONNAND",
  "TOK_REDUCTIONOR", "$accept", "start", "constant_expression",
  "attribute_instances", "attribute_instance", "attr_specs", "attr_name",
  "constant_primary", "primary_literal", "time_literal", "number",
  "real_number", "integral_number", "identifier", "simple_identifier",
  "escaped_identifier", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const unsigned short yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const unsigned char yyr1[] =
{
       0,    52,    53,    54,    54,    54,    54,    54,    54,    54,
      54,    54,    54,    54,    54,    54,    54,    54,    54,    54,
      54,    54,    54,    54,    54,    54,    54,    54,    54,    54,
      54,    54,    54,    54,    54,    54,    54,    54,    54,    54,
      54,    54,    54,    54,    54,    54,    54,    54,    54,    54,
      54,    54,    54,    54,    54,    54,    54,    54,    54,    54,
      54,    54,    54,    54,    54,    54,    54,    54,    54,    54,
      54,    54,    54,    54,    54,    54,    54,    54,    54,    55,
      55,    56,    56,    56,    56,    57,    57,    57,    57,    58,
      59,    60,    60,    60,    60,    61,    61,    62,    62,    63,
      63,    64,    64,    64,    64,    64,    65,    65,    66,    67
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const unsigned char yyr2[] =
{
       0,     2,     4,     1,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       4,     4,     4,     4,     4,     4,     4,     4,     4,     4,
       4,     4,     4,     4,     4,     4,     4,     4,     4,     4,
       4,     4,     4,     4,     4,     4,     5,     6,     3,     1,
       2,     5,     7,     6,     8,     2,     4,     3,     5,     1,
       1,     1,     1,     1,     1,     2,     2,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const unsigned char yydefact[] =
{
       0,     0,     0,     0,     1,     0,     0,     0,     0,     0,
       0,     0,     0,   103,   101,   102,   105,   104,    99,   100,
       0,    93,    94,     0,     0,     0,     3,    90,    92,    91,
      98,    97,     0,     0,    79,    10,     0,    12,     0,     8,
       0,     5,     0,     4,     0,     7,     0,     6,     0,    95,
      96,     0,    13,     0,     9,     0,    11,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     2,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    80,    20,    22,    18,
      15,    14,    17,    16,    78,    23,    19,    21,     0,     0,
       0,    37,     0,    36,     0,    39,     0,    40,     0,    38,
       0,    25,     0,    26,     0,    28,     0,    27,     0,    29,
       0,    43,     0,    42,     0,    30,     0,    31,     0,    32,
       0,    33,     0,    34,     0,    24,     0,    46,     0,    47,
       0,    48,     0,    49,     0,    35,     0,    41,     0,    44,
       0,    45,     0,   108,   109,     0,    89,   106,   107,     0,
       0,    63,    62,    65,    66,    64,    51,    52,    54,    53,
      55,    69,    68,    56,    57,    58,    59,    60,    50,    72,
      73,    74,    75,    61,    67,    70,    71,     0,     0,     0,
       0,    76,     0,     0,    81,    85,     0,     0,    77,     0,
       0,     0,    83,    87,    82,     0,    86,     0,    84,    88
};

/* YYDEFGOTO[NTERM-NUM]. */
static const short yydefgoto[] =
{
      -1,     2,    48,   130,    34,   190,   155,    26,    27,    28,
      29,    30,    31,   156,   157,   158
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -181
static const short yypact[] =
{
     -12,     0,    30,   340,  -181,   824,   824,   824,   824,   824,
     824,   824,   340,  -181,  -181,    -8,  -181,  -181,    -7,  -181,
     824,  -181,  -181,   824,   824,   423,  -181,  -181,  -181,  -181,
    -181,  -181,    21,   824,  -181,  -181,   824,  -181,   824,  -181,
     824,  -181,   824,  -181,   824,  -181,   824,  -181,   467,  -181,
    -181,   824,  -181,   824,  -181,   824,  -181,   374,   374,   374,
     374,   374,   374,   374,   374,   374,   374,   374,   374,   374,
     374,   374,   374,   374,   374,  -181,   374,   374,   374,   374,
     374,   374,   374,   374,   374,   -20,  -181,  -181,  -181,  -181,
    -181,  -181,  -181,  -181,  -181,  -181,  -181,  -181,   272,   511,
     374,   684,   374,   724,   374,   739,   374,   777,   374,   790,
     374,   825,   374,   -14,   374,   -14,   374,   -14,   374,   -14,
     374,    29,   374,    29,   374,    -9,   374,    -9,   374,     2,
     374,     2,   374,     2,   374,   825,   374,   825,   374,   825,
     374,   825,   374,   825,   374,  -181,   374,   777,   374,    29,
     374,    29,   374,  -181,  -181,   -10,  -181,  -181,  -181,   340,
     555,   684,   724,   739,   777,   790,   825,   -14,   -14,   -14,
     -14,    29,    29,    -9,    -9,     2,     2,     2,   825,   825,
     825,   825,   825,  -181,   777,    29,    29,   340,    16,   -20,
      -1,   643,   340,   599,  -181,    32,    18,   -20,   643,   306,
       1,   340,  -181,    35,  -181,    26,   643,   340,  -181,   643
};

/* YYPGOTO[NTERM-NUM].  */
static const short yypgoto[] =
{
    -181,  -181,    -3,   152,   -18,  -140,  -180,   232,  -181,  -181,
    -181,  -181,  -181,  -181,  -181,  -181
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -1
static const unsigned char yytable[] =
{
      25,   187,    68,    69,    70,    71,    72,    73,    74,   195,
     188,    72,    73,    74,   153,    86,   154,   203,    86,   196,
      86,   205,    86,     1,    86,     3,    86,   189,    86,    81,
       4,    83,    84,    86,    81,    86,   197,    86,   197,    49,
      50,    85,   194,   201,   202,    81,   207,    70,    71,    72,
      73,    74,   208,   200,    99,   101,   103,   105,   107,   109,
     111,   113,   115,   117,   119,   121,   123,   125,   127,   129,
     131,   133,    81,   135,   137,   139,   141,   143,   145,   147,
     149,   151,    86,     0,    86,     0,    86,     0,    86,     0,
      86,     0,    86,     0,    86,     0,    86,   160,    86,   161,
      86,   162,    86,   163,    86,   164,    86,   165,    86,   166,
      86,   167,    86,   168,    86,   169,    86,   170,    86,   171,
      86,   172,    86,   173,    86,   174,    86,   175,    86,   176,
      86,   177,    86,   178,    86,   179,     0,   180,     0,   181,
       0,   182,     0,   183,     0,   184,     0,   185,     0,   186,
       0,     0,     0,     0,     0,     0,   191,    33,    36,    38,
      40,    42,    44,    46,     0,     0,     0,     0,     0,     0,
       0,     0,    51,     0,     0,    53,    55,     0,     0,     0,
       0,     0,     0,     0,   193,     0,     0,     0,     0,   198,
       0,     0,     0,     0,     0,     0,   129,     0,   206,     0,
       0,     0,     0,     0,   209,     0,     0,     0,     0,   100,
     102,   104,   106,   108,   110,   112,   114,   116,   118,   120,
     122,   124,   126,   128,     0,   132,   134,     0,   136,   138,
     140,   142,   144,   146,   148,   150,   152,    35,    37,    39,
      41,    43,    45,    47,     0,     0,     0,     0,     0,     0,
       0,     0,    52,     0,     0,    54,    56,     0,     0,     0,
       0,     0,     0,     0,     0,    87,     0,     0,    88,     0,
      89,     0,    90,     0,    91,     0,    92,     0,    93,     5,
       6,     7,     0,    95,     0,    96,     0,    97,     0,     0,
       8,     9,    85,     0,     0,    10,    11,    12,     0,    13,
      14,    15,    16,    17,    18,    19,     0,     0,     0,     0,
       0,     0,     0,     5,     6,     7,    20,     0,     0,     0,
      21,    22,    23,    24,     8,     9,     0,     0,     0,    10,
      11,    98,   204,    13,    14,    15,    16,    17,    18,    19,
       0,     0,     0,     0,     0,     0,     0,     5,     6,     7,
      20,     0,     0,     0,    21,    22,    23,    24,     8,     9,
       0,     0,     0,    10,    11,    12,     0,    13,    14,    15,
      16,    17,    18,    19,     0,     0,     0,     0,     0,     0,
       0,     5,     6,     7,    20,     0,     0,     0,    21,    22,
      23,    24,     8,     9,     0,     0,     0,    10,    11,    98,
       0,    13,    14,    15,    16,    17,    18,    19,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    20,     0,
       0,     0,    21,    22,    23,    24,    57,     0,    58,    59,
      60,    61,    62,    63,     0,    64,    65,    66,    67,    68,
      69,    70,    71,    72,    73,    74,     0,     0,     0,    75,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      57,     0,    58,    59,    60,    61,    62,    63,     0,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
       0,     0,     0,    94,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    57,   159,    58,    59,    60,    61,
      62,    63,     0,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    76,
      77,    78,    79,    80,    81,    82,    83,    84,    57,   192,
      58,    59,    60,    61,    62,    63,     0,    64,    65,    66,
      67,    68,    69,    70,    71,    72,    73,    74,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    76,    77,    78,    79,    80,    81,    82,
      83,    84,    57,     0,    58,    59,    60,    61,    62,    63,
       0,    64,    65,    66,    67,    68,    69,    70,    71,   199,
      73,    74,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   189,    76,    77,    78,
      79,    80,    81,    82,    83,    84,    57,     0,    58,    59,
      60,    61,    62,    63,     0,    64,    65,    66,    67,    68,
      69,    70,    71,    72,    73,    74,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      59,    60,    61,    62,    63,     0,    64,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    76,    77,    78,    79,    80,    81,    82,    83,
      84,    60,    61,    62,    63,     0,    64,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    61,    62,    63,
       0,    64,    65,    66,    67,    68,    69,    70,    71,    72,
      73,    74,    76,    77,    78,    79,    80,    81,    82,    83,
      84,     0,     0,     0,     0,     0,     0,    76,    77,    78,
      79,    80,    81,    82,    83,    84,    62,    63,     0,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      63,     0,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,     0,     0,    76,    77,    78,    79,    80,
      81,     0,    83,    84,     0,     0,     0,     0,    76,    77,
      78,    79,    80,    81,     0,    83,    84,    64,    65,    66,
      67,    68,    69,    70,    71,    72,    73,    74,     0,    32,
       0,    13,    14,    15,    16,    17,    18,    19,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    81,     0,
      83,    84,    21,    22
};

static const short yycheck[] =
{
       3,    11,    16,    17,    18,    19,    20,    21,    22,   189,
      20,    20,    21,    22,    34,    33,    36,   197,    36,    20,
      38,    20,    40,    35,    42,    25,    44,    37,    46,    43,
       0,    45,    46,    51,    43,    53,    37,    55,    37,    47,
      47,    20,    26,    11,    26,    43,    11,    18,    19,    20,
      21,    22,    26,   193,    57,    58,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    70,    71,    72,
      73,    74,    43,    76,    77,    78,    79,    80,    81,    82,
      83,    84,   100,    -1,   102,    -1,   104,    -1,   106,    -1,
     108,    -1,   110,    -1,   112,    -1,   114,   100,   116,   102,
     118,   104,   120,   106,   122,   108,   124,   110,   126,   112,
     128,   114,   130,   116,   132,   118,   134,   120,   136,   122,
     138,   124,   140,   126,   142,   128,   144,   130,   146,   132,
     148,   134,   150,   136,   152,   138,    -1,   140,    -1,   142,
      -1,   144,    -1,   146,    -1,   148,    -1,   150,    -1,   152,
      -1,    -1,    -1,    -1,    -1,    -1,   159,     5,     6,     7,
       8,     9,    10,    11,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    -1,    -1,    23,    24,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   187,    -1,    -1,    -1,    -1,   192,
      -1,    -1,    -1,    -1,    -1,    -1,   199,    -1,   201,    -1,
      -1,    -1,    -1,    -1,   207,    -1,    -1,    -1,    -1,    57,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    -1,    73,    74,    -1,    76,    77,
      78,    79,    80,    81,    82,    83,    84,     5,     6,     7,
       8,     9,    10,    11,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    -1,    -1,    23,    24,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    33,    -1,    -1,    36,    -1,
      38,    -1,    40,    -1,    42,    -1,    44,    -1,    46,     7,
       8,     9,    -1,    51,    -1,    53,    -1,    55,    -1,    -1,
      18,    19,    20,    -1,    -1,    23,    24,    25,    -1,    27,
      28,    29,    30,    31,    32,    33,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,     7,     8,     9,    44,    -1,    -1,    -1,
      48,    49,    50,    51,    18,    19,    -1,    -1,    -1,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    32,    33,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,     7,     8,     9,
      44,    -1,    -1,    -1,    48,    49,    50,    51,    18,    19,
      -1,    -1,    -1,    23,    24,    25,    -1,    27,    28,    29,
      30,    31,    32,    33,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,     7,     8,     9,    44,    -1,    -1,    -1,    48,    49,
      50,    51,    18,    19,    -1,    -1,    -1,    23,    24,    25,
      -1,    27,    28,    29,    30,    31,    32,    33,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    44,    -1,
      -1,    -1,    48,    49,    50,    51,     3,    -1,     5,     6,
       7,     8,     9,    10,    -1,    12,    13,    14,    15,    16,
      17,    18,    19,    20,    21,    22,    -1,    -1,    -1,    26,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    38,    39,    40,    41,    42,    43,    44,    45,    46,
       3,    -1,     5,     6,     7,     8,     9,    10,    -1,    12,
      13,    14,    15,    16,    17,    18,    19,    20,    21,    22,
      -1,    -1,    -1,    26,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    38,    39,    40,    41,    42,
      43,    44,    45,    46,     3,     4,     5,     6,     7,     8,
       9,    10,    -1,    12,    13,    14,    15,    16,    17,    18,
      19,    20,    21,    22,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    38,
      39,    40,    41,    42,    43,    44,    45,    46,     3,     4,
       5,     6,     7,     8,     9,    10,    -1,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    38,    39,    40,    41,    42,    43,    44,
      45,    46,     3,    -1,     5,     6,     7,     8,     9,    10,
      -1,    12,    13,    14,    15,    16,    17,    18,    19,    20,
      21,    22,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    37,    38,    39,    40,
      41,    42,    43,    44,    45,    46,     3,    -1,     5,     6,
       7,     8,     9,    10,    -1,    12,    13,    14,    15,    16,
      17,    18,    19,    20,    21,    22,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    38,    39,    40,    41,    42,    43,    44,    45,    46,
       6,     7,     8,     9,    10,    -1,    12,    13,    14,    15,
      16,    17,    18,    19,    20,    21,    22,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    38,    39,    40,    41,    42,    43,    44,    45,
      46,     7,     8,     9,    10,    -1,    12,    13,    14,    15,
      16,    17,    18,    19,    20,    21,    22,     8,     9,    10,
      -1,    12,    13,    14,    15,    16,    17,    18,    19,    20,
      21,    22,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    -1,    -1,    -1,    -1,    -1,    -1,    38,    39,    40,
      41,    42,    43,    44,    45,    46,     9,    10,    -1,    12,
      13,    14,    15,    16,    17,    18,    19,    20,    21,    22,
      10,    -1,    12,    13,    14,    15,    16,    17,    18,    19,
      20,    21,    22,    -1,    -1,    38,    39,    40,    41,    42,
      43,    -1,    45,    46,    -1,    -1,    -1,    -1,    38,    39,
      40,    41,    42,    43,    -1,    45,    46,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    -1,    25,
      -1,    27,    28,    29,    30,    31,    32,    33,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    43,    -1,
      45,    46,    48,    49
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const unsigned char yystos[] =
{
       0,    35,    53,    25,     0,     7,     8,     9,    18,    19,
      23,    24,    25,    27,    28,    29,    30,    31,    32,    33,
      44,    48,    49,    50,    51,    54,    59,    60,    61,    62,
      63,    64,    25,    55,    56,    59,    55,    59,    55,    59,
      55,    59,    55,    59,    55,    59,    55,    59,    54,    47,
      47,    55,    59,    55,    59,    55,    59,     3,     5,     6,
       7,     8,     9,    10,    12,    13,    14,    15,    16,    17,
      18,    19,    20,    21,    22,    26,    38,    39,    40,    41,
      42,    43,    44,    45,    46,    20,    56,    59,    59,    59,
      59,    59,    59,    59,    26,    59,    59,    59,    25,    54,
      55,    54,    55,    54,    55,    54,    55,    54,    55,    54,
      55,    54,    55,    54,    55,    54,    55,    54,    55,    54,
      55,    54,    55,    54,    55,    54,    55,    54,    55,    54,
      55,    54,    55,    54,    55,    54,    55,    54,    55,    54,
      55,    54,    55,    54,    55,    54,    55,    54,    55,    54,
      55,    54,    55,    34,    36,    58,    65,    66,    67,     4,
      54,    54,    54,    54,    54,    54,    54,    54,    54,    54,
      54,    54,    54,    54,    54,    54,    54,    54,    54,    54,
      54,    54,    54,    54,    54,    54,    54,    11,    20,    37,
      57,    54,     4,    54,    26,    58,    20,    37,    54,    20,
      57,    11,    26,    58,    26,    20,    54,    11,    26,    54
};

#if ! defined (YYSIZE_T) && defined (__SIZE_TYPE__)
# define YYSIZE_T __SIZE_TYPE__
#endif
#if ! defined (YYSIZE_T) && defined (size_t)
# define YYSIZE_T size_t
#endif
#if ! defined (YYSIZE_T)
# if defined (__STDC__) || defined (__cplusplus)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# endif
#endif
#if ! defined (YYSIZE_T)
# define YYSIZE_T unsigned int
#endif

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { 								\
      yyerror ("syntax error: cannot back up");\
      YYERROR;							\
    }								\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

/* YYLLOC_DEFAULT -- Compute the default location (before the actions
   are run).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)		\
   ((Current).first_line   = (Rhs)[1].first_line,	\
    (Current).first_column = (Rhs)[1].first_column,	\
    (Current).last_line    = (Rhs)[N].last_line,	\
    (Current).last_column  = (Rhs)[N].last_column)
#endif

/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (0)

# define YYDSYMPRINT(Args)			\
do {						\
  if (yydebug)					\
    yysymprint Args;				\
} while (0)

# define YYDSYMPRINTF(Title, Token, Value, Location)		\
do {								\
  if (yydebug)							\
    {								\
      YYFPRINTF (stderr, "%s ", Title);				\
      yysymprint (stderr, 					\
                  Token, Value);	\
      YYFPRINTF (stderr, "\n");					\
    }								\
} while (0)

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_stack_print (short *bottom, short *top)
#else
static void
yy_stack_print (bottom, top)
    short *bottom;
    short *top;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (/* Nothing. */; bottom <= top; ++bottom)
    YYFPRINTF (stderr, " %d", *bottom);
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_reduce_print (int yyrule)
#else
static void
yy_reduce_print (yyrule)
    int yyrule;
#endif
{
  int yyi;
  unsigned int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %u), ",
             yyrule - 1, yylno);
  /* Print the symbols being reduced, and their result.  */
  for (yyi = yyprhs[yyrule]; 0 <= yyrhs[yyi]; yyi++)
    YYFPRINTF (stderr, "%s ", yytname [yyrhs[yyi]]);
  YYFPRINTF (stderr, "-> %s\n", yytname [yyr1[yyrule]]);
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (Rule);		\
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YYDSYMPRINT(Args)
# define YYDSYMPRINTF(Title, Token, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   SIZE_MAX < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#if defined (YYMAXDEPTH) && YYMAXDEPTH == 0
# undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined (__GLIBC__) && defined (_STRING_H)
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
#   if defined (__STDC__) || defined (__cplusplus)
yystrlen (const char *yystr)
#   else
yystrlen (yystr)
     const char *yystr;
#   endif
{
  register const char *yys = yystr;

  while (*yys++ != '\0')
    continue;

  return yys - yystr - 1;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined (__GLIBC__) && defined (_STRING_H) && defined (_GNU_SOURCE)
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
#   if defined (__STDC__) || defined (__cplusplus)
yystpcpy (char *yydest, const char *yysrc)
#   else
yystpcpy (yydest, yysrc)
     char *yydest;
     const char *yysrc;
#   endif
{
  register char *yyd = yydest;
  register const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

#endif /* !YYERROR_VERBOSE */



#if YYDEBUG
/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yysymprint (FILE *yyoutput, int yytype, YYSTYPE *yyvaluep)
#else
static void
yysymprint (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  if (yytype < YYNTOKENS)
    {
      YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
# ifdef YYPRINT
      YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
    }
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  switch (yytype)
    {
      default:
        break;
    }
  YYFPRINTF (yyoutput, ")");
}

#endif /* ! YYDEBUG */
/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yydestruct (int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yytype, yyvaluep)
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  switch (yytype)
    {

      default:
        break;
    }
}


/* Prevent warnings from -Wmissing-prototypes.  */

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM);
# else
int yyparse ();
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */



/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;



/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM)
# else
int yyparse (YYPARSE_PARAM)
  void *YYPARSE_PARAM;
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
  
  register int yystate;
  register int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack.  */
  short	yyssa[YYINITDEPTH];
  short *yyss = yyssa;
  register short *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  register YYSTYPE *yyvsp;



#define YYPOPSTACK   (yyvsp--, yyssp--)

  YYSIZE_T yystacksize = YYINITDEPTH;

  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;


  /* When reducing, the number of symbols on the RHS of the reduced
     rule.  */
  int yylen;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed. so pushing a state here evens the stacks.
     */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack. Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	short *yyss1 = yyss;


	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow ("parser stack overflow",
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),

		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyoverflowlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyoverflowlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	short *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyoverflowlab;
	YYSTACK_RELOCATE (yyss);
	YYSTACK_RELOCATE (yyvs);

#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;


      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YYDSYMPRINTF ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */
  YYDPRINTF ((stderr, "Shifting token %s, ", yytname[yytoken]));

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;


  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  yystate = yyn;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:

    {
															g_genResultValue = yyvsp[-1];
															return 0;
														;}
    break;

  case 4:

    { yyval = SVValue((long)(-(long)yyvsp[0])); ;}
    break;

  case 5:

    { yyval = SVValue((long)(+(long)yyvsp[0])); ;}
    break;

  case 6:

    { yyval = SVValue((long)(!(long)yyvsp[0])); ;}
    break;

  case 7:

    { yyval = SVValue((long)(~(long)yyvsp[0])); ;}
    break;

  case 8:

    { yyerror("Unary reduction operator '&' not supported"); ;}
    break;

  case 9:

    { yyerror("Unary reduction operator '~&' not supported"); ;}
    break;

  case 10:

    { yyerror("Unary reduction operator '|' not supported"); ;}
    break;

  case 11:

    { yyerror("Unary reduction operator '~|' not supported"); ;}
    break;

  case 12:

    { yyerror("Unary reduction operator '^' not supported"); ;}
    break;

  case 13:

    { yyerror("Unary reduction operators '~^' and '^~' not supported"); ;}
    break;

  case 14:

    { yyval = SVValue((long)(-(long)yyvsp[-1])); yyerror("Ignoring attribute(s)"); ;}
    break;

  case 15:

    { yyval = SVValue((long)(+(long)yyvsp[-1])); yyerror("Ignoring attribute(s)"); ;}
    break;

  case 16:

    { yyval = SVValue((long)(!(long)yyvsp[-1])); yyerror("Ignoring attribute(s)"); ;}
    break;

  case 17:

    { yyval = SVValue((long)(~(long)yyvsp[-1])); yyerror("Ignoring attribute(s)"); ;}
    break;

  case 18:

    { yyerror("Unary reduction operator '&' not supported"); yyerror("Ignoring attribute(s)"); ;}
    break;

  case 19:

    { yyerror("Unary reduction operator '~&' not supported"); yyerror("Ignoring attribute(s)"); ;}
    break;

  case 20:

    { yyerror("Unary reduction operator '|' not supported"); yyerror("Ignoring attribute(s)"); ;}
    break;

  case 21:

    { yyerror("Unary reduction operator '~|' not supported"); yyerror("Ignoring attribute(s)"); ;}
    break;

  case 22:

    { yyerror("Unary reduction operator '^' not supported"); yyerror("Ignoring attribute(s)"); ;}
    break;

  case 23:

    { yyerror("Unary reduction operators '~^' and '^~' not supported"); yyerror("Ignoring attribute(s)"); ;}
    break;

  case 24:

    { yyval = SVValue( (long)((double)yyvsp[-2] == (double)yyvsp[0]) ); ;}
    break;

  case 25:

    { yyval = SVValue( (long)((double)yyvsp[-2] != (double)yyvsp[0]) ); ;}
    break;

  case 26:

    { yyval = SVValue( (double)((double)yyvsp[-2] < (double)yyvsp[0]) ); ;}
    break;

  case 27:

    { yyval = SVValue( (double)((double)yyvsp[-2] <= (double)yyvsp[0]) ); ;}
    break;

  case 28:

    { yyval = SVValue( (double)((double)yyvsp[-2] > (double)yyvsp[0]) ); ;}
    break;

  case 29:

    { yyval = SVValue( (double)((double)yyvsp[-2] >= (double)yyvsp[0]) ); ;}
    break;

  case 30:

    { yyval = SVValue( (double)((double)yyvsp[-2] + (double)yyvsp[0]) ); ;}
    break;

  case 31:

    { yyval = SVValue( (double)((double)yyvsp[-2] - (double)yyvsp[0]) ); ;}
    break;

  case 32:

    { yyval = SVValue( (double)((double)yyvsp[-2] * (double)yyvsp[0]) ); ;}
    break;

  case 33:

    { yyval = SVValue( (double)((double)yyvsp[-2] / (double)yyvsp[0]) ); if((double)yyvsp[0] == 0.0) yyerror("Divide by zero"); ;}
    break;

  case 34:

    { yyval = SVValue( (long)((long)yyvsp[-2] % (long)yyvsp[0]) ); ;}
    break;

  case 35:

    { yyval = SVValue( pow(yyvsp[-2],yyvsp[0]) ); ;}
    break;

  case 36:

    { yyval = SVValue( (long)((long)yyvsp[-2] && (long)yyvsp[0]) ); ;}
    break;

  case 37:

    { yyval = SVValue( (long)((long)yyvsp[-2] || (long)yyvsp[0]) ); ;}
    break;

  case 38:

    { yyval = SVValue( (long)((long)yyvsp[-2] & (long)yyvsp[0]) ); ;}
    break;

  case 39:

    { yyval = SVValue( (long)((long)yyvsp[-2] | (long)yyvsp[0]) ); ;}
    break;

  case 40:

    { yyval = SVValue( (long)((long)yyvsp[-2] ^ (long)yyvsp[0]) ); ;}
    break;

  case 41:

    { yyval = SVValue( (long)((long)yyvsp[-2] ^~ (long)yyvsp[0]) ); ;}
    break;

  case 42:

    { yyval = SVValue( (long)((long)yyvsp[-2] >> (long)yyvsp[0]) ); ;}
    break;

  case 43:

    { yyval = SVValue( (long)((long)yyvsp[-2] << (long)yyvsp[0]) ); ;}
    break;

  case 44:

    { yyerror("Arithmetic shift not supported"); ;}
    break;

  case 45:

    { yyerror("Arithmetic shift not supported"); ;}
    break;

  case 46:

    { yyerror("4-State operator not supported"); ;}
    break;

  case 47:

    { yyerror("4-State operator not supported"); ;}
    break;

  case 48:

    { yyerror("4-State operator not supported"); ;}
    break;

  case 49:

    { yyerror("4-State operator not supported"); ;}
    break;

  case 50:

    { yyval = SVValue( (long)((double)yyvsp[-3] == (double)yyvsp[0]) ); yyerror("Ignoring attribute(s)"); ;}
    break;

  case 51:

    { yyval = SVValue( (long)((double)yyvsp[-3] != (double)yyvsp[0]) ); yyerror("Ignoring attribute(s)"); ;}
    break;

  case 52:

    { yyval = SVValue( (double)((double)yyvsp[-3] < (double)yyvsp[0]) ); yyerror("Ignoring attribute(s)"); ;}
    break;

  case 53:

    { yyval = SVValue( (double)((double)yyvsp[-3] <= (double)yyvsp[0]) ); yyerror("Ignoring attribute(s)"); ;}
    break;

  case 54:

    { yyval = SVValue( (double)((double)yyvsp[-3] > (double)yyvsp[0]) ); yyerror("Ignoring attribute(s)"); ;}
    break;

  case 55:

    { yyval = SVValue( (double)((double)yyvsp[-3] >= (double)yyvsp[0]) ); yyerror("Ignoring attribute(s)"); ;}
    break;

  case 56:

    { yyval = SVValue( (double)((double)yyvsp[-3] + (double)yyvsp[0]) ); yyerror("Ignoring attribute(s)"); ;}
    break;

  case 57:

    { yyval = SVValue( (double)((double)yyvsp[-3] - (double)yyvsp[0]) ); yyerror("Ignoring attribute(s)"); ;}
    break;

  case 58:

    { yyval = SVValue( (double)((double)yyvsp[-3] * (double)yyvsp[0]) ); yyerror("Ignoring attribute(s)"); ;}
    break;

  case 59:

    { yyval = SVValue( (double)((double)yyvsp[-3] / (double)yyvsp[0]) ); if((double)yyvsp[0] == 0.0) yyerror("Divide by zero"); yyerror("Ignoring attribute(s)"); ;}
    break;

  case 60:

    { yyval = SVValue( (long)((long)yyvsp[-3] % (long)yyvsp[0]) ); yyerror("Ignoring attribute(s)"); ;}
    break;

  case 61:

    { yyval = SVValue( pow(yyvsp[-3],yyvsp[0]) ); yyerror("Ignoring attribute(s)"); ;}
    break;

  case 62:

    { yyval = SVValue( (long)((long)yyvsp[-3] && (long)yyvsp[0]) ); yyerror("Ignoring attribute(s)"); ;}
    break;

  case 63:

    { yyval = SVValue( (long)((long)yyvsp[-3] || (long)yyvsp[0]) ); yyerror("Ignoring attribute(s)"); ;}
    break;

  case 64:

    { yyval = SVValue( (long)((long)yyvsp[-3] & (long)yyvsp[0]) ); yyerror("Ignoring attribute(s)"); ;}
    break;

  case 65:

    { yyval = SVValue( (long)((long)yyvsp[-3] | (long)yyvsp[0]) ); yyerror("Ignoring attribute(s)"); ;}
    break;

  case 66:

    { yyval = SVValue( (long)((long)yyvsp[-3] ^ (long)yyvsp[0]) ); yyerror("Ignoring attribute(s)"); ;}
    break;

  case 67:

    { yyval = SVValue( (long)((long)yyvsp[-3] ^~ (long)yyvsp[0]) ); yyerror("Ignoring attribute(s)"); ;}
    break;

  case 68:

    { yyval = SVValue( (long)((long)yyvsp[-3] >> (long)yyvsp[0]) ); yyerror("Ignoring attribute(s)"); ;}
    break;

  case 69:

    { yyval = SVValue( (long)((long)yyvsp[-3] << (long)yyvsp[0]) ); yyerror("Ignoring attribute(s)"); ;}
    break;

  case 70:

    { yyerror("Arithmetic shift not supported"); yyerror("Ignoring attribute(s)"); ;}
    break;

  case 71:

    { yyerror("Arithmetic shift not supported"); yyerror("Ignoring attribute(s)"); ;}
    break;

  case 72:

    { yyerror("4-State operator not supported"); yyerror("Ignoring attribute(s)"); ;}
    break;

  case 73:

    { yyerror("4-State operator not supported"); yyerror("Ignoring attribute(s)"); ;}
    break;

  case 74:

    { yyerror("4-State operator not supported"); yyerror("Ignoring attribute(s)"); ;}
    break;

  case 75:

    { yyerror("4-State operator not supported"); yyerror("Ignoring attribute(s)"); ;}
    break;

  case 76:

    { if((long)yyvsp[-4]) {yyval = (double)yyvsp[-2]; } else { yyval = (double)yyvsp[0];  } ;}
    break;

  case 77:

    {  if((long)yyvsp[-5]) {yyval = (double)yyvsp[-3]; } else { yyval = (double)yyvsp[-1];} yyerror("Ignoring attribute(s)"); ;}
    break;

  case 78:

    { yyval = (double)yyvsp[-1]; ;}
    break;

  case 99:

    { yyval = parseSVFloat(); ;}
    break;

  case 100:

    { yyval = parseSVFloat(); ;}
    break;

  case 101:

    { yyval = parseSVDecimal(); ;}
    break;

  case 102:

    { yyval = parseSVDecimal(); ;}
    break;

  case 103:

    { yyval = parseSVOctal(); ;}
    break;

  case 104:

    { yyval = parseSVBinary(); ;}
    break;

  case 105:

    { yyval = parseSVHexadecimal(); ;}
    break;


    }

/* Line 1000 of yacc.c.  */


  yyvsp -= yylen;
  yyssp -= yylen;


  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;


  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (YYPACT_NINF < yyn && yyn < YYLAST)
	{
	  YYSIZE_T yysize = 0;
	  int yytype = YYTRANSLATE (yychar);
	  const char* yyprefix;
	  char *yymsg;
	  int yyx;

	  /* Start YYX at -YYN if negative to avoid negative indexes in
	     YYCHECK.  */
	  int yyxbegin = yyn < 0 ? -yyn : 0;

	  /* Stay within bounds of both yycheck and yytname.  */
	  int yychecklim = YYLAST - yyn;
	  int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
	  int yycount = 0;

	  yyprefix = ", expecting ";
	  for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	      {
		yysize += yystrlen (yyprefix) + yystrlen (yytname [yyx]);
		yycount += 1;
		if (yycount == 5)
		  {
		    yysize = 0;
		    break;
		  }
	      }
	  yysize += (sizeof ("syntax error, unexpected ")
		     + yystrlen (yytname[yytype]));
	  yymsg = (char *) YYSTACK_ALLOC (yysize);
	  if (yymsg != 0)
	    {
	      char *yyp = yystpcpy (yymsg, "syntax error, unexpected ");
	      yyp = yystpcpy (yyp, yytname[yytype]);

	      if (yycount < 5)
		{
		  yyprefix = ", expecting ";
		  for (yyx = yyxbegin; yyx < yyxend; ++yyx)
		    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
		      {
			yyp = yystpcpy (yyp, yyprefix);
			yyp = yystpcpy (yyp, yytname[yyx]);
			yyprefix = " or ";
		      }
		}
	      yyerror (yymsg);
	      YYSTACK_FREE (yymsg);
	    }
	  else
	    yyerror ("syntax error; also virtual memory exhausted");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror ("syntax error");
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* If at end of input, pop the error token,
	     then the rest of the stack, then return failure.  */
	  if (yychar == YYEOF)
	     for (;;)
	       {
		 YYPOPSTACK;
		 if (yyssp == yyss)
		   YYABORT;
		 YYDSYMPRINTF ("Error: popping", yystos[*yyssp], yyvsp, yylsp);
		 yydestruct (yystos[*yyssp], yyvsp);
	       }
        }
      else
	{
	  YYDSYMPRINTF ("Error: discarding", yytoken, &yylval, &yylloc);
	  yydestruct (yytoken, &yylval);
	  yychar = YYEMPTY;

	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

#ifdef __GNUC__
  /* Pacify GCC when the user code never invokes YYERROR and the label
     yyerrorlab therefore never appears in user code.  */
  if (0)
     goto yyerrorlab;
#endif

  yyvsp -= yylen;
  yyssp -= yylen;
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;

      YYDSYMPRINTF ("Error: popping", yystos[*yyssp], yyvsp, yylsp);
      yydestruct (yystos[yystate], yyvsp);
      YYPOPSTACK;
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  YYDPRINTF ((stderr, "Shifting error token, "));

  *++yyvsp = yylval;


  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#ifndef yyoverflow
/*----------------------------------------------.
| yyoverflowlab -- parser overflow comes here.  |
`----------------------------------------------*/
yyoverflowlab:
  yyerror ("parser stack overflow");
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  return yyresult;
}






